[Leetcode 452] 最少需要射出多少支箭Minimum Number of Arrows to Burst Balloons 贪心 重载

Posted leetcode刷题中

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了[Leetcode 452] 最少需要射出多少支箭Minimum Number of Arrows to Burst Balloons 贪心 重载相关的知识,希望对你有一定的参考价值。

【题目】

There are a number of spherical balloons spread in two-dimensional space. For each balloon, provided input is the start and end coordinates of the horizontal diameter. Since it‘s horizontal, y-coordinates don‘t matter and hence the x-coordinates of start and end of the diameter suffice. Start is always smaller than end. There will be at most 104 balloons.

An arrow can be shot up exactly vertically from different points along the x-axis. A balloon with xstart and xend bursts by an arrow shot at x if xstart ≤ x ≤ xend. There is no limit to the number of arrows that can be shot. An arrow once shot keeps travelling up infinitely. The problem is to find the minimum number of arrows that must be shot to burst all balloons.

Example:

Input:
[[10,16], [2,8], [1,6], [7,12]]

Output:
2

Explanation:
One way is to shoot one arrow for example at x = 6 (bursting the balloons [2,8] and [1,6]) and another arrow at x = 11 (bursting the other two balloons).
箭射气球,气球是一个区间,区间重叠的气球可以一起被射下来。问最少需要多少支箭。

【思路】

1、重载sort

Arrays.sort(points, (a, b) -> a[1] - b[1])等价于:(更快)

        Arrays.sort(points, new Comparator<int[]>(){
            public int compare(int[] a, int[] b) {
                return a[1] - b[1];
            }

2、贪心

设[1,4] [2,5] [6,9] [7,11] [12,19]

当区间重叠时,可以用同一箭射下。

因此仅在 p[0] > tmp[1],即第i个点的left>边界tmp的right时,cnt++。

【代码】

class Solution {
    public int findMinArrowShots(int[][] points) {
        if(points.length==0)
            return 0;
        int cnt=1;
        Arrays.sort(points, new Comparator<int[]>(){
            public int compare(int[] a, int[] b) {
                return a[1] - b[1];
            }
        });
        int pos = points[0][1];
        for (int i = 1; i < points.length; i++) {
            if (points[i][0] > pos) {
                pos = points[i][1];
                cnt++;
        }
    }
    return cnt;
    }

 

更容易理解:

class Solution {
    public int findMinArrowShots(int[][] points) {
        if(points.length==0)
            return 0;
        int cnt=1;
        Arrays.sort(points, new Comparator<int[]>(){
            public int compare(int[] a, int[] b) {
                return a[1] - b[1];
            }
        });
        int pos = points[0][1];
        for (int[] p : points) {
            if (p[0] > pos) {
                pos = p[1];
                cnt++;
        }
    }
    return cnt;
    }
}

 

以上是关于[Leetcode 452] 最少需要射出多少支箭Minimum Number of Arrows to Burst Balloons 贪心 重载的主要内容,如果未能解决你的问题,请参考以下文章

Leetcode 452.用最少数量的箭引爆气球

Leetcode刷题Python452. 用最少数量的箭引爆气球

452. 用最少数量的箭引爆气球

贪心452. 用最少数量的箭引爆气球

数字问题-LeetCode 452453454455456459(KMP算法)

452. 用最少数量的箭引爆气球-贪心算法-Comparator比较器使用